import { load } from "protobufjs"

const sp = await load(`${import.meta.dir}/sp.proto`)
const signup = sp.lookupType('SignUpRequest')

const msg = {
	url: 'https://auth-callback.spotify.com/r/ios/music/signup',
	tag2: {
		username: 'test',
		dob: `2000-00-00`,
		gender: 1,
		tag4: {
			tag1: {
				blank_tag1: 1
			},
			tag2: {},
			tag3: {},
		},
		tag101: {
			signupemail: 'test@gmail.com',
			password: 'test',
		},
	},
	tag3: {
		client_id: 'test',
		os: 'test',
		appversion: '8.8.54',
		stringoffset: 1,
		random_hex32: 'testing',
	},
	tag4: {
		client_mobile: 'client_mobile',
	},
}

const message = signup.fromObject(msg)
const buf = signup.encode(message).finish()

const message2 = signup.decode(buf)
console.log(message2.toJSON())